config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for :users

  resources :cars

  get '/' => 'cars#index'

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/ability.rb
# frozen_string_literal: true

# The class that defines the logged-in user permissions for accessing
# the car controller actions
class Ability
  include CanCan::Ability

  def initialize(user)
    can %i[update delete], Car, user: user

    # Define abilities for the passed in user here. For example:
    #
    #   user ||= User.new # guest user (not logged in)
    #   if user.admin?
    #     can :manage, :all
    #   else
    #     can :read, :all
    #   end
    #
    # The first argument to `can` is the action you are giving the user
    # permission to do.
    # If you pass :manage it will apply to every action. Other common actions
    # here are :read, :create, :update and :destroy.
    #
    # The second argument is the resource the user can perform the action on.
    # If you pass :all it will apply to every resource. Otherwise pass a Ruby
    # class of the resource.
    #
    # The third argument is an optional hash of conditions to further filter the
    # objects.
    # For example, here the user can only update published articles.
    #
    #   can :update, Article, :published => true
    #
    # See the wiki for details:
    # https://github.com/CanCanCommunity/cancancan/wiki/Defining-Abilities
  end
end

app/models/application_record.rb
# frozen_string_literal: true

# The top model that other models extend
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/car.rb
# frozen_string_literal: true

# Car model
class Car < ApplicationRecord
  include PgSearch::Model
  include OrderableByAttributes

  belongs_to :user

  # validations
  validates_presence_of :brand, :model, :description

  # filters definitions
  multisearchable(
    against: %i[brand model description],
    additional_attributes: lambda { |car|
      {
        body_type: car.body_type,
        seats: car.seats,
        doors: car.doors,
        fuel_consumption_urban: car.fuel_consumption_urban,
        fuel_consumption_extra_urban: car.fuel_consumption_extra_urban,
        fuel_type: car.fuel_type,
        acceleration: car.acceleration,
        maximum_speed: car.maximum_speed,
        power: car.power,
        engine_displacement: car.engine_displacement,
        weight: car.weight,
        trunk_space_min: car.trunk_space_min,
        trunk_space_max: car.trunk_space_max,
        fuel_tank_capacity: car.fuel_tank_capacity,
        length: car.length,
        width: car.width,
        height: car.height,
        drivetrain: car.drivetrain
      }
    }
  )

  def name
    [brand, model].compact.join(' ')
  end

  class << self
    def multisearch(params)
      QueryObjects::Car.multisearch(filters: params, scope: Car.all)
    end

    def seats
      [2, 3, 4, 5, 6, 7, 8].freeze
    end

    def doors
      [2, 4, 6].freeze
    end

    def fuel_type
      %w[gasoline diesel electricity].freeze
    end

    def drivetrain
      ['all-wheel drive', 'four-wheel drive', 'front-wheel drive', 'rear-wheel drive'].freeze
    end

    def body_type
      Rails.cache.fetch('body_types', expires_in: 12.months) do
        distinct.pluck(:body_type).freeze
      end
    end
  end
end

app/models/concerns/orderable_by_attributes.rb
# frozen_string_literal: true

module OrderableByAttributes
  extend ActiveSupport::Concern

  included do
    scope :by_recently_created, -> { order(created_at: :desc) }
  end
end

app/models/objects/filter.rb
# frozen_string_literal: true

module Objects
  # Class used for instantiating filters
  class Filter
    attr_accessor :id, :text, :facets, :url
    attr_writer :active

    def initialize(*args, &block)
      id, text, url, value = args
      @id = id
      @url = url if url.present?
      @active = value.present? ? value : false
      @text = @active ? "#{text}: #{value}" : text
      @facets = Car.send(id).map(&block) if block.present?
    end

    def active
      @active || false
    end
  end
end

app/models/objects/link.rb
# frozen_string_literal: true

module Objects
  # Link class used for describing a filter link
  class Link
    attr_accessor :text, :url

    def initialize(text = nil, url = nil)
      @text = text
      @url = url
    end
  end
end

app/models/objects/sorting.rb
# frozen_string_literal: true

module Objects
  # Class used for instantiating the sorting options for the sort drop-down
  class Sorting
    attr_reader :id, :text, :url

    def initialize(*args)
      id, text, url = args
      @id = id
      @text = text
      @url = url
    end
  end
end

app/models/query_objects/car.rb
# frozen_string_literal: true

module QueryObjects
  # A class that implements the search functionality for the Car model
  class Car
    def initialize(scope = Car.all)
      @scope = scope
    end

    def self.multisearch(scope:, filters:)
      new(scope).multisearch(filters)
    end

    def multisearch(filters)
      safe_filters = filters || {}

      query(safe_filters)
      sort_and_order(safe_filters)
    end

    private

    def query(filters)
      query_filters = query_filters(filters)

      if query_filters.present?
        %i[brand model description]
          .select { |key| query_filters[key].present? }
          .each { |key| @scope = PgSearch.multisearch(query_filters[key]) }

        %i[doors seats body_type fuel_type drivetrain]
          .select { |key| query_filters[key].present? }
          .each { |key| @scope = @scope.where(key => query_filters[key]) }
      end

      @scope
    end

    def sort_and_order(filters)
      sorting = sorting_filters(filters)

      @scope.send("by_#{sorting}") if sorting.present?
      @scope.order(id: :asc) unless sorting.present?

      @scope
    end

    def query_filters(filters)
      new_filters = filters.dup
      new_filters.delete(:sorting)
      new_filters
    end

    def sorting_filters(filters)
      filters[:sorting]
    end
  end
end

app/models/user.rb
# frozen_string_literal: true

class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  has_many :cars
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  include Pagy::Backend
end

app/controllers/cars_controller.rb
# frozen_string_literal: true

# Defines the actions used for displaying , adding, deleting or updating a car
class CarsController < ApplicationController
  before_action :find_car, only: %i[show edit update destroy]

  def index
    page = params[:page] || 1
    @searched_cars = Car.multisearch(params[:search])
    @pagy, @cars = pagy(@searched_cars, page: page)
  end

  def show; end

  def new
    @car = Car.new
  end

  def create
    @car = current_user.cars.build(car_params)
    if @car.save
      redirect_to @car
    else
      render 'new'
    end
  end

  def edit
    authorize! :update, @car
  end

  def update
    if @car.update(car_params)
      redirect_to @car
    else
      render 'edit'
    end
  end

  def destroy; end

  private

  def find_car
    @car = Car.find(params[:id])
  end

  def car_params
    params.require(:car).permit(
      :brand, :model, :description, :body_type, :seats, :doors,
      :fuel_consumption_urban, :fuel_consumption_extra_urban, :fuel_type, :acceleration, :maximum_speed,
      :power, :engine_displacement, :trunk_space_min, :trunk_space_max, :fuel_tank_capacity,
      :length, :width, :height, :drivetrain, :photo, :user_id, :page, :sorting
    )
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
  include Pagy::Frontend
end

app/helpers/cars_helper.rb
# frozen_string_literal: true

# All the helper methods used by Cars controller and views
module CarsHelper
end

app/views/cars/_tile.html.erb
<div class="col-md-6 col-sm-6 project-item mix">
    <div class="project-thumb">
        <div class="thumbnail" style="background-image: url(assets/<%=car.photo ? car.photo : ''%>);"></div>
        <div class="overlay-b">
            <div class="overlay-inner">
              <%= link_to '', car, class: 'fancybox fa fa-expand' %>
            </div>
        </div>
    </div>
    <div class="box-content project-detail">
        <h2>
          <%= link_to car do %>
            <%= car.name %>
          <% end %>
        </h2>
        <p>
          <%= car.description %>
        </p>
    </div>
</div>

app/views/cars/edit.html.erb
<div class="content-wrapper">
    <div class="inner-container container">
        <div class="row">
            <div class="section-header col-md-12">
                <h2>Update your car details</h2>
            </div>
        </div>

        <div class="base-form">
            <div class="box-content col-md-12">
                <div class="row">
                    <div class="col-md-7">
                        <h3 class="contact-title">Complete the car details</h3>
                        <div class="base-form-inner">
                            <%= simple_form_for @car, html: {id: "edit_car_form"} do |f| %>
                                <fieldset>
                                    <legend>General specs</legend>
                                    <p>
                                        <%= f.label :brand, 'Brand' %>
                                        <%= f.text_field :brand %>
                                        <%= f.error :brand %>
                                    </p>
                                    <p>
                                        <%= f.label :model, 'Model' %>
                                        <%= f.text_field :model %>
                                        <%= f.error :model %>
                                    </p>
                                    <p>
                                        <%= f.label :description, 'Description' %>
                                        <%= f.text_area :description %>
                                        <%= f.error :description %>
                                    </p>
                                    <p>
                                        <%= f.label :body_type, 'Body type' %>
                                        <%= f.text_field :body_type %>
                                        <%= f.error :body_type %>
                                    </p>
                                    <p>
                                        <%= f.label :seats, 'Seats' %>
                                        <%= f.select :seats, Car.seats %>
                                        <%= f.error :seats %>
                                    </p>
                                    <p>
                                        <%= f.label :doors, 'Doors' %>
                                        <%= f.select :doors, Car.doors %>
                                        <%= f.error :doors %>
                                    </p>
                                </fieldset>
                                <fieldset>
                                    <legend>Performance specs</legend>
                                    <p>
                                        <%= f.label :fuel_consumption_urban, 'Fuel consumption in urban area' %>
                                        <%= f.text_field :fuel_consumption_urban %>
                                        <%= f.error :fuel_consumption_urban %>
                                    </p>
                                    <p>
                                        <%= f.label :fuel_consumption_extra_urban, 'Fuel consumption in extra urban area' %>
                                        <%= f.text_field :fuel_consumption_extra_urban %>
                                        <%= f.error :fuel_consumption_extra_urban %>
                                    </p>
                                    <p>
                                        <%= f.label :fuel_type, 'Fuel type' %>
                                        <%= f.select :fuel_type, Car.fuel_type %>
                                        <%= f.error :fuel_type %>
                                    </p>
                                    <p>
                                        <%= f.label :acceleration, 'Acceleration' %>
                                        <%= f.text_field :acceleration %>
                                        <%= f.error :acceleration %>
                                    </p>
                                    <p>
                                        <%= f.label :maximum_speed, 'Maximum_speed' %>
                                        <%= f.text_field :maximum_speed %>
                                        <%= f.error :maximum_speed %>
                                    </p>
                                </fieldset>
                                <fieldset>
                                    <legend>Engine specs</legend>
                                    <p>
                                        <%= f.label :power, 'Power' %>
                                        <%= f.text_field :power %>
                                        <%= f.error :power %>
                                    </p>
                                    <p>
                                        <%= f.label :engine_displacement, 'Engine displacement' %>
                                        <%= f.text_field :engine_displacement %>
                                        <%= f.error :engine_displacement %>
                                    </p>
                                </fieldset>
                                <fieldset>
                                    <legend>Space, volume and weights</legend>
                                    <p>
                                        <%= f.label :trunk_space_min, 'Trunk space min' %>
                                        <%= f.text_field :trunk_space_min %>
                                        <%= f.error :trunk_space_min %>
                                    </p>
                                    <p>
                                        <%= f.label :trunk_space_max, 'Trunk space max' %>
                                        <%= f.text_field :trunk_space_max %>
                                        <%= f.error :trunk_space_max %>
                                    </p>
                                    <p>
                                        <%= f.label :fuel_tank_capacity, 'Fuel tank capacity' %>
                                        <%= f.text_field :fuel_tank_capacity %>
                                        <%= f.error :fuel_tank_capacity %>
                                    </p>
                                </fieldset>
                                <fieldset>
                                    <legend>Dimensions</legend>
                                    <p>
                                        <%= f.label :length, 'Length' %>
                                        <%= f.text_field :length %>
                                        <%= f.error :length %>
                                    </p>
                                    <p>
                                        <%= f.label :width, 'Width' %>
                                        <%= f.text_field :width %>
                                        <%= f.error :width %>
                                    </p>
                                    <p>
                                        <%= f.label :height, 'Height' %>
                                        <%= f.text_field :height %>
                                        <%= f.error :height %>
                                    </p>
                                </fieldset>
                                <fieldset>
                                    <legend>Drivetrain</legend>
                                    <p>
                                        <%= f.label :drivetrain, 'Drive train' %>
                                        <%= f.select :drivetrain, Car.drivetrain %>
                                        <%= f.error :drivetrain %>
                                    </p>
                                    <p>
                                        <%= f.label :photo, 'Photo' %>
                                        <%= f.text_field :photo %>
                                        <%= f.error :photo %>
                                    </p>
                                    <%= f.submit 'Update', :class => 'mainBtn' %>
                                    <%= link_to 'Cancel', :back, :class => 'mainBtn' %>
                                </fieldset>
                            <% end %>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
</div>

app/views/cars/index.html.erb
<% search = SearchPresenter.new(params) %>

<div class="content-wrapper">
  <div class="inner-container container">
    <div class="row">
      <div class="section-header col-md-12">
        <h2>Our cars offers</h2>
        <span><%= link_to 'Add your car', new_car_path %></span>
      </div>
    </div>

    <div class="projects-holder-2 row">
      <div class="filter-categories col-sm-3">
        <ul class="project-filter">
          <% search.filters.select{|x| x.active }.each do |filter| %>
            <li class="filter" data-filter="<%= filter.id %>">
              <%= link_to filter.text, filter.url %>
            </li>
          <% end %>

          <% search.filters.select{|x| !x.active }.each do |filter| %>
            <li class="filter" data-filter="<%= filter.id %>">
              <h2><%= filter.text %></h2>
              <% if filter.facets %>
                <% filter.facets.each do |facet| %>
                  <span><%= link_to facet.text, facet.url %></span>
                <% end %>
              <% elsif filter.id != :clear %>
                <%= simple_form_for :search, url: filter.url, method: :get do |f| %>
                  <%= f.text_field filter.id %>
                  <% search.active_params_except(filter.id).each do |key, value| %>
                    <%= f.hidden_field key, :value => value %>
                  <% end %>
                <% end %>
              <% end %>
            </li>
          <% end %>
        </ul>
      </div>

      <div class="projects-holder col-md-9 col-sm-9">
        <div class="row">
          <nav class="pagination clearfix">
            <%= render partial: "shared/nav", locals: { pagy: @pagy } %>
            <%= render partial: "shared/sorting", locals: { sortings: search.sortings } %>
          </nav>
        </div>

        <div class="row">
          <% @cars.each do |car| %>
            <%= render partial: "tile", locals: {car: car.respond_to?(:searchable) ? car.searchable : car} %>
          <% end %>
        </div>

        <div class="load-more">
          <a href="javascript:void(0)" class="load-more">Load More</a>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/cars/show.html.erb
<div class="content-wrapper">
    <div class="inner-container container">
        <div class="row">
            <div class="section-header col-md-12">
                <h2><%= @car.brand %></h2>
            </div>
        </div>

        <div class="project-detail row">
            <div class="project-slider col-md-12">
                <%= image_tag @car.photo ? @car.photo : '', alt: "Slide 1", border: 0 %>
                <a href="#" class="slidesjs-previous slidesjs-navigation">&lt;</a> 
                <a href="#" class="slidesjs-next slidesjs-navigation">&gt;</a>
            </div>
            <div class="project-infos col-md-12">
                <div class="box-content">
                    <h2 class="project-title"><%= @car.description %></h2>
                    <span><%= link_to 'Update your car offer', edit_car_path %></span>
                    <div class="details">
                        <div>
                            <%= image_tag @car.photo ? @car.photo : '', width: '100%', alt: @car.description %>
                        </div>
                        <div>
                            <table>
                                <tr>
                                    <td>Brand</td><td><%= @car.brand %></td>
                                </tr>
                                <tr>
                                    <td>Model</td><td><%= @car.model %></td>
                                </tr>
                                <tr>
                                    <td>Body type</td><td><%= @car.body_type %></td>
                                </tr>
                                <tr>
                                    <td>Seats</td><td><%= @car.seats %></td>
                                </tr>
                                <tr>
                                    <td>Doors</td><td><%= @car.doors %></td>
                                </tr>
                                <tr>
                                    <td>Drivetrain</td><td><%= @car.drivetrain %></td>
                                </tr>
                            </table>
                        </div>
                    </div>
                    <ul class="project-meta">
                        <li><i class="fa fa-calendar-o"></i>31 October 2019</li>
                        <li><i class="fa fa-envelope-o"></i><a href="mailto:info@company.com">info@company.com</a></li>
                    </ul>
                </div>
            </div>
        </div>

    </div>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Automoto</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto+Slab:400,700,300,100">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:400,400italic,300italic,300,500,500italic,700,900">
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'main', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>

    <div class="main-header">
        <div class="row">
            <div class="main-header-left col-md-3 col-sm-6 col-xs-8">
                <a id="search-icon" class="btn-left fa fa-search" href="#search-overlay"></a>
                <div id="search-overlay">
                    <a href="#search-overlay" class="close-search"><i class="fa fa-times-circle"></i></a>
                    <div class="search-form-holder">
                        <h2>Type keywords and hit enter</h2>
                        <%= simple_form_for :search, url: cars_path, method: :get do |f| %>
                          <%= f.text_field :description %>
                        <% end %>
                    </div>
                </div>
            </div>

            <div class="menu-wrapper col-md-9 col-sm-6 col-xs-4">
                <a href="#" class="toggle-menu visible-sm visible-xs"><i class="fa fa-bars"></i></a>
                <ul class="sf-menu hidden-xs hidden-sm">
                    <li class="navbar-text float-right">
                      <% if user_signed_in? %>
                        Logged in as <strong><%= current_user.email %></strong>.
                        <%= link_to "Edit profile", edit_user_registration_path, :class => 'navbar-link' %> |
                        <%= link_to "Logout", destroy_user_session_path, method: :delete, :class => 'navbar-link' %>
                      <% else %>
                        <%= link_to "Sign up", new_user_registration_path, :class => 'navbar-link' %> |
                        <%= link_to "Login", new_user_session_path, :class => 'navbar-link' %>
                      <% end %>
                    </li>
                    <li><%= link_to 'Cars', cars_path %></li>
                    <li><a href="#">Contact</a></li>
                </ul>
            </div>
        </div>
    </div>

    <%= yield %>
  </body>
</html>

app/views/shared/_nav.html.erb
<%#
  This template is i18n-ready: if you don't use i18n, then you can replace the pagy_t
  calls with the actual strings ("&lsaquo; Prev", "Next &rsaquo;", "&hellip;").

  The link variable is set to a proc that returns the link tag.
  Usage: link.call( page_number [, text [, extra_attributes_string ]])
-%>
<% link = pagy_link_proc(pagy) -%>
<%#                            -%><div aria-label="pager" class="pagy_nav" role="navigation">
<% if pagy.prev                -%>  <span class="btn-left arrow-left fa"><%== link.call(pagy.prev, '', 'class="fa-angle-left" aria-label="previous"') %></span>
<% else                        -%>  <span class="btn-left arrow-left fa fa-angle-left"></span>
<% end                         -%>
<% pagy.series.each do |item| # series example: [1, :gap, 7, 8, "9", 10, 11, :gap, 36] -%>
<%   if    item.is_a?(Integer) -%>  <span class="btn-left fa"><%== link.call(item) %></span>
<%   elsif item.is_a?(String)  -%>  <span class="btn-left fa"><%= item %></span>
<%   elsif item == :gap        -%>  <span class="page gap"><%== pagy_t('pagy.nav.gap') %></span>
<%   end                       -%>
<% end                         -%>
<% if pagy.next                -%>  <span class="btn-left arrow-right fa"><%== link.call(pagy.next, '', 'class="fa-angle-right" aria-label="next"') %></span>
<% else                        -%>  <span class="btn-left arrow-right fa fa-angle-right disabled"></span>
<% end                         -%>
<%#                            -%></div>

app/views/shared/_sorting.html.erb
<div class="sorting">
<%= simple_form_for :search, url: request.url, method: :get, html: {id: 'search_sorting_form'} do |f| %>
  <%= f.select :sorting,
    options_for_select(sortings.map {|x| [x.text, x.id] }, params[:search].present? ? params[:search][:sorting] : nil), 
    {}, {class: 'search-sorting'} %>
<% end %>
</div>

app/views/users/shared/_error_messages.html.erb
<% if resource.errors.any? %>
  <div id="error_explanation">
    <h2>
      <%= I18n.t("errors.messages.not_saved",
                 count: resource.errors.count,
                 resource: resource.class.model_name.human.downcase)
       %>
    </h2>
    <ul>
      <% resource.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name), :class => 'mainBtn' %>
<% end %>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name), :class => 'mainBtn' %>
<% end %>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name), :class => 'mainBtn' %>
<% end %>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name), :class => 'mainBtn' %><br />
<% end %>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name), :class => 'mainBtn' %><br />
<% end %>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider), method: :post, :class => 'mainBtn' %><br />
  <% end %>
<% end %>